package jarnal;

import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.awt.print.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.lang.Math.*;
import java.lang.Number.*;
import java.io.*;
import java.awt.image.BufferedImage;
import javax.imageio.*;

import jarnal.Jpages;
import jarnal.Jtool;
import jarnal.Jpar;

public class Jarnal extends JApplet{

    static Dimension frameSize = new Dimension(738, 992);
    static int nWins = 0;

    static String ext = ".jaj";	
    static String openfile = "";
    static String openbgfile = "";
    static String openmfile = "";
    static String meta = "";
    static boolean template = false;
    static HashSet wins = new HashSet();
    static boolean isApplet = false;

    JrnlPane jrnlPane;
    JLabel statusBar;
    JFrame gJrnlFrame;
    Toolkit toolkit;

    String fname = "";
    String cwd = "";
    String bgfile = "";

    TreeSet bookmarks = new TreeSet();
    static TreeSet allBookmarks = new TreeSet();

    Jtool jt = new Jtool();
    Jtool jtd = new Jtool();
    Jtool jth = new Jtool();
    String old_color = "black";
    boolean hideCursor = true;
    boolean textMode = false;
    boolean saveOnExit = false;
    boolean saveBookmarks = false;
    boolean updateBookmarks = true;
    boolean saveBg = false;
    String netServer = "";
    String netOptions = "";
    String uniqueID;

    boolean dirty = false;
    boolean fitWidth = true;
    int dragOp = 0;

    int sbarSize = 20;

    public static int setarg(String[] args, int iarg, int len){
		String oldopenfile = openfile;
		openfile = args[iarg];
		int ret = iarg + 1;
		if (openfile.equals("-t")){
			if(iarg >= len - 1) openfile = "";
			else {
				template = true;
				openfile = args[iarg + 1];
				ret++;
			}
			return ret;
		}
		if (openfile.equals("-b")){
			openfile = oldopenfile;
			if(iarg < len - 1) openbgfile = args[iarg + 1];
			ret++;
		}
		if (openfile.equals("-m")){
			openfile = oldopenfile;
			if(iarg < len - 1) openmfile = args[iarg + 1];
			ret++;
		}
		return ret;
    }

   public static void pipe(){
	if(openfile.length() > 7){
		if(openfile.substring(0,7).equals("http://")){
			HtmlPost hp = new HtmlPost(openfile, null, null, null, null);
			openfile = hp.pipe(".jaj");
		}
	}
	if(openbgfile.length() > 7){
		if(openbgfile.substring(0,7).equals("http://")){
			HtmlPost hp = new HtmlPost(openbgfile, null, null, null, null);
			openbgfile = hp.pipe(".jbg");
		}
	}
	if(openmfile.length() > 7){
		if(openmfile.substring(0,7).equals("http://")){
			HtmlPost hp = new HtmlPost(openmfile, null, null, null, null);
			openmfile = hp.pipe(".jam");
		}
	}
    }

    public static void main(String[] args) {
	int len = java.lang.reflect.Array.getLength(args);
	int iarg = 0;
	while(iarg < len){
		iarg = setarg(args, iarg, len);
	}
	pipe();
	if(!openmfile.equals("")){
		try{
			FileInputStream fin = new FileInputStream(openmfile);
			int nmax = 10000; 
			byte b[] = new byte[nmax + 1];
			int nread = 0;
			while((nread = fin.read(b, 0, nmax)) >= 0)meta = meta + new String(b, 0, nread); 
		}
		catch(IOException ex){System.err.println(ex);}
	}
        initJ();
    }

    public void init(){
	isApplet = true;
	meta = "[Globals]\n";
	String parm = getParameter("netServer");
	if(parm != null) meta = meta + "netServer=" + parm + "\n";
	meta = meta + "\n[Net Options]\n";
	parm = getParameter("p0");
	int ip = 1;
	while(parm != null){
		meta=meta + parm + "\n";
		parm = getParameter("p" + ip);
		ip++;	
	}
    	try {
        	javax.swing.SwingUtilities.invokeAndWait(new Runnable() {
            	public void run() {
                	newJarnal("Jarnal");
            	}
        	});
    	} catch (Exception e) {
        	System.err.println("createGUI didn't successfully complete");
    	}
    }
    
    public static Jarnal initJ() { 
	String title = "Jarnal";
	if(!openfile.equals("") && !template) {
		File temp = new File(openfile);
		title = title + " - " + temp.getName();    
	}
        return newJarnal(title);
    }

    public void checkClose(){
	nWins--;
	wins.remove(this);
	if(nWins == 0) System.exit(0);
    }
    
    public static Jarnal newJarnal(String title){
        JFrame jrnlFrame = new JFrame(title);
        final Jarnal controller = new Jarnal();
	wins.add(controller);
        JrnlPane jp = controller.buildUI(jrnlFrame);
        jrnlFrame.setSize(frameSize);  
        jrnlFrame.setVisible(true);
        jp.requestFocus();
	jp.repaint();
	nWins++;
        return controller;
    }
    
  
    public JrnlPane buildUI(JFrame jf){
	bgfile = openbgfile;
	openbgfile = "";
	jf.addWindowListener(new JrnlClosing());
	jf.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        buildMenu(jf);
        gJrnlFrame = jf;
	jf.addComponentListener(new JrnlSizeListener());
	toolkit = jf.getToolkit();
        return buildContainer(jf.getContentPane());
    }
	
    public void setDirs(String cwd, String fname){
	this.cwd = cwd;
	this.fname = fname;
	jrnlPane.load();
	jrnlPane.setCursor();
    }
    
//UI Definition    
    
    public JMenuItem bmi(String action){
        JMenuItem item;
        item = new JMenuItem(action);
        item.addActionListener(new JrnlActionListener(action));
        return item;
    }

    public JButton bjb(String action){
        JButton item;
        item = new JButton(action);
        item.addActionListener(new JrnlActionListener(action, item));
        return item;
    }

    public JButton bjb(String action, Icon icon){
        JButton item;
        item = new JButton(icon);
        item.addActionListener(new JrnlActionListener(action, item));
	item.setToolTipText(action);
        return item;
    }

    JMenu bmk = new JMenu("Bookmarks");
    JMenu dbmk = new JMenu("Delete Bookmarks");
    static JMenu allbmk = new JMenu("All Bookmarks");
    JCheckBoxMenuItem soe = new JCheckBoxMenuItem("Save On Exit");
    JCheckBoxMenuItem sbmk = new JCheckBoxMenuItem("Save Bookmarks"); 
    JCheckBoxMenuItem abmk = new JCheckBoxMenuItem("Autoupdate Bookmarks");
    JCheckBoxMenuItem sbg = new JCheckBoxMenuItem("Save Background With File");
	
    public void buildMenu(JFrame jf){			
        JMenuBar jmb = new JMenuBar();
        JMenu file = new JMenu("File");
        file.add(bmi("New"));
	if(!isApplet){
        	file.add(bmi("Open"));
		file.addSeparator();
		file.add(bmi("Open Background"));
		file.add(bmi("Remove Background"));
        	file.addSeparator();
        	file.add(bmi("Save"));
        	file.add(bmi("Save As"));
		file.add(bmi("Snapshot"));
	}
	file.add(bmi("Network Save"));
	file.addSeparator();
	sbg.addActionListener(new JrnlActionListener("Save Background With File"));
	file.add(bmi("Network Save Options"));
	soe.addActionListener(new JrnlActionListener("Save On Exit"));
	file.add(sbg);
	if(!isApplet){
		file.add(soe);
		sbmk.addActionListener(new JrnlActionListener("Save Bookmarks"));
		file.add(sbmk);
		abmk.addActionListener(new JrnlActionListener("Autoupdate Bookmarks"));
		file.add(abmk);
        	file.addSeparator();
	}
	file.add(bmi("Restore Default Configuration"));
	if(!isApplet) file.add(dbmk);
	file.addSeparator();
        file.add(bmi("Print"));
        file.addSeparator();
        file.add(bmi("Exit"));
	if(!isApplet){
		file.addSeparator();
		file.add(bmk);
		file.add(allbmk);
	}
    	jmb.add(file);
        
        JMenu edit = new JMenu("Edit");
        edit.add(bmi("Undo"));
        edit.add(bmi("Redo"));
        edit.addSeparator();
	if(!isApplet){
		edit.add(bmi("Cut Text"));
		edit.add(bmi("Copy Text"));
		edit.addSeparator();
		edit.add(bmi("Paste Text"));
		edit.addSeparator();
	}
	JMenu page = new JMenu("Page");
	if(!isApplet){
        	page.add(bmi("Cut Page"));
        	page.add(bmi("Copy Page"));
	}
	page.add(bmi("Duplicate Page"));
        page.addSeparator();
	if(!isApplet){
        	page.add(bmi("Paste Page Before"));
        	page.add(bmi("Paste Page After"));
		page.addSeparator();
		page.add(bmi("Insert Page Before"));
		page.add(bmi("Replace Page"));
		page.add(bmi("Insert Page After"));
		page.addSeparator();
	}
	page.add(bmi("Clear Page"));
	page.addSeparator();
	page.add(bmi("Delete Page"));
	edit.add(page);
        
	jmb.add(edit);
        
        JMenu view = new JMenu("View");
        view.add(bmi("Fit Width"));
        view.addSeparator();
        view.add(bmi("Zoom In"));
        view.add(bmi("Zoom Out"));
	view.addSeparator();
	view.add(bmi("Highlight Lines"));
	view.addSeparator();
	view.add(bmi("Redraw Page"));
        jmb.add(view);

	JMenu transparency = new JMenu("Transparency");
	transparency.add(bmi("opaque"));
	transparency.add(bmi("translucent"));
	transparency.add(bmi("transparent"));

	JMenu paper = new JMenu("Paper");
	paper.add(bmi("Toggle Background"));
	paper.add(transparency);
	paper.addSeparator();
	paper.add(bmi("Lined"));
	paper.add(bmi("Plain"));
	paper.add(bmi("Graph"));
	paper.addSeparator();
	paper.add(bmi("Toggle Landscape"));
	paper.addSeparator();
	paper.add(bmi("Normal Size"));
	paper.add(bmi("Index Card"));
	paper.add(bmi("Fit to Background"));
	paper.addSeparator();

	JMenu lines = new JMenu("Lines");
	lines.add(bmi("Thick Lines"));
	lines.add(bmi("Medium Lines"));
	lines.add(bmi("Thin Lines"));
	paper.add(lines);

	jmb.add(paper);

	JMenu format = new JMenu("Format");

	format.add(bmi("Bold Text"));
	format.add(bmi("Italic Text"));
	format.add(bmi("Underline Text"));

	JMenu tcolor = new JMenu("Text Color");
	tcolor.add(bmi("Black Text"));
	tcolor.add(bmi("Blue Text"));
	tcolor.add(bmi("Green Text"));
	tcolor.add(bmi("Gray Text"));
	tcolor.add(bmi("Magenta Text"));	
	tcolor.add(bmi("Orange Text"));
	tcolor.add(bmi("Pink Text"));
	tcolor.add(bmi("Red Text"));
	tcolor.add(bmi("White Text"));
	tcolor.add(bmi("Yellow Text"));
	format.add(tcolor);

	JMenu size = new JMenu("Text Size");
	size.add(bmi(" 6pt"));
	size.add(bmi(" 7pt"));
	size.add(bmi(" 8pt"));
	size.add(bmi(" 9pt"));
	size.add(bmi("10pt"));
	size.add(bmi("11pt"));
	size.add(bmi("12pt"));
	size.add(bmi("13pt"));
	size.add(bmi("14pt"));
	size.add(bmi("15pt"));
	size.add(bmi("16pt"));
	size.add(bmi("18pt"));
	size.add(bmi("20pt"));
	size.add(bmi("22pt"));
	size.add(bmi("24pt"));
	size.add(bmi("26pt"));
	size.add(bmi("28pt"));
	size.add(bmi("32pt"));
	size.add(bmi("36pt"));
	size.add(bmi("40pt"));
	size.add(bmi("48pt"));
	size.add(bmi("54pt"));
	size.add(bmi("60pt"));
	size.add(bmi("66pt"));
	size.add(bmi("72pt"));
	size.add(bmi("80pt"));
	size.add(bmi("88pt"));
	size.add(bmi("96pt"));
	format.add(size);

	JMenu font = new JMenu("Font");
	String fn[] = GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
	for(int i = 0; i < fn.length; i++) font.add(bmi("Font " + fn[i]));
	format.add(font);

	format.addSeparator();
	format.add(bmi("Set Text Default"));

	jmb.add(format);
        
        JMenu tools = new JMenu("Tools");
	
	JMenu pen = new JMenu("Weight");
	pen.add(bmi("Set Fine"));
	pen.add(bmi("Set Medium"));
	pen.add(bmi("Set Heavy"));
	pen.add(bmi("Set Fat"));
	tools.add(pen);

	JMenu color = new JMenu("Color");
	color.add(bmi("black"));
	color.add(bmi("blue"));
	color.add(bmi("green"));
	color.add(bmi("gray"));
	color.add(bmi("magenta"));	
	color.add(bmi("orange"));
	color.add(bmi("pink"));
	color.add(bmi("red"));
	color.add(bmi("white"));
	color.add(bmi("yellow"));
	tools.add(color);
	tools.add(bmi("Highlighter"));
	tools.add(bmi("Pen"));
	tools.add(bmi("Default"));

	tools.addSeparator();
	tools.add(bmi("Set Default"));

	tools.addSeparator();	
	tools.add(bmi("Eraser"));
	tools.add(bmi("Razor"));
	tools.add(bmi("Top Eraser"));
	tools.add(bmi("Bottom Eraser"));
	tools.add(bmi("Ruler"));
	tools.add(bmi("Select"));

        jmb.add(tools);
        
       
        JMenu help = new JMenu("Help");
	help.add(bmi("About"));
        jmb.add(help);
        
        jf.setJMenuBar(jmb);
    }

    JButton saveButton;	
	
    public JrnlPane buildContainer(Container container){

	ImageIcon fsave = new ImageIcon(Jarnal.class.getResource("images/filesave.png"));
	ImageIcon undo = new ImageIcon(Jarnal.class.getResource("images/undo.png"));
	ImageIcon redo = new ImageIcon(Jarnal.class.getResource("images/redo.png"));
	ImageIcon minus = new ImageIcon(Jarnal.class.getResource("images/viewmag-.png"));
	ImageIcon plus = new ImageIcon(Jarnal.class.getResource("images/viewmag+.png"));
	ImageIcon fit = new ImageIcon(Jarnal.class.getResource("images/viewmagfit.png"));
	ImageIcon eraser = new ImageIcon(Jarnal.class.getResource("images/eraser.png"));
	ImageIcon red = new ImageIcon(Jarnal.class.getResource("images/pencilred.png"));
	ImageIcon blk = new ImageIcon(Jarnal.class.getResource("images/pencilblk.png"));
	ImageIcon blu = new ImageIcon(Jarnal.class.getResource("images/pencilblu.png"));
	ImageIcon highyel = new ImageIcon(Jarnal.class.getResource("images/highlighteryel.png"));
	ImageIcon highmag = new ImageIcon(Jarnal.class.getResource("images/highlightermag.png"));
	ImageIcon highdef = new ImageIcon(Jarnal.class.getResource("images/highlighterdef.png"));
	ImageIcon white = new ImageIcon(Jarnal.class.getResource("images/whiteout.png"));
	ImageIcon left = new ImageIcon(Jarnal.class.getResource("images/1leftarrow.png"));
	ImageIcon leftleft = new ImageIcon(Jarnal.class.getResource("images/2leftarrow.png"));
	ImageIcon right = new ImageIcon(Jarnal.class.getResource("images/1rightarrow.png"));
	ImageIcon rightright = new ImageIcon(Jarnal.class.getResource("images/2rightarrow.png"));
	ImageIcon select = new ImageIcon(Jarnal.class.getResource("images/select.png"));
	ImageIcon newpage = new ImageIcon(Jarnal.class.getResource("images/new.png"));
	ImageIcon def = new ImageIcon(Jarnal.class.getResource("images/default.png"));
	ImageIcon fin = new ImageIcon(Jarnal.class.getResource("images/fine.png"));
	ImageIcon med = new ImageIcon(Jarnal.class.getResource("images/medium.png"));
	ImageIcon hev = new ImageIcon(Jarnal.class.getResource("images/heavy.png"));
	ImageIcon fat = new ImageIcon(Jarnal.class.getResource("images/fat.png"));
	ImageIcon razor = new ImageIcon(Jarnal.class.getResource("images/razor.png"));
	ImageIcon ruler = new ImageIcon(Jarnal.class.getResource("images/ruler.png"));
	ImageIcon thumbs = new ImageIcon(Jarnal.class.getResource("images/thumbs.png"));
	ImageIcon text = new ImageIcon(Jarnal.class.getResource("images/text.png"));
	ImageIcon clock = new ImageIcon(Jarnal.class.getResource("images/clock.png"));

	Image cursorD = toolkit.getImage(Jarnal.class.getResource("images/dotblk.png"));
	Image cursorB = toolkit.getImage(Jarnal.class.getResource("images/blank.png"));
	Image cursorX = toolkit.getImage(Jarnal.class.getResource("images/box.png"));
	Image cursorW = toolkit.getImage(Jarnal.class.getResource("images/whitecursor.png"));
	Image cursorH = toolkit.getImage(Jarnal.class.getResource("images/highcursor.png"));

	JPanel x = new JPanel(new BorderLayout());
        container.add(x, BorderLayout.NORTH);
	
        JToolBar jtb = new JToolBar();
        JButton item;
	if(isApplet){
		saveButton = bjb("Network Save", fsave);
		jtb.add(saveButton);
	}
	else {
		saveButton = bjb("Save", fsave);
		jtb.add(saveButton);
	}
	jtb.addSeparator();
    	jtb.add(bjb("Undo", undo));	
        jtb.add(bjb("Redo", redo));
	jtb.addSeparator();
        jtb.add(bjb("First Page", leftleft));
        jtb.add(bjb("Previous Page", left));
        jtb.add(bjb("Next Page", right));
        jtb.add(bjb("Last Page", rightright));
	jtb.addSeparator();
        jtb.add(bjb("Zoom Out", minus));
        jtb.add(bjb("Fit Width", fit));
        jtb.add(bjb("Zoom In", plus));
	jtb.addSeparator();
	jtb.add(bjb("Thumbs", thumbs));
	jtb.add(bjb("New Page", newpage));
        x.add(jtb, BorderLayout.NORTH);
        
        jtb = new JToolBar();
	jtb.add(bjb("Default Pen", def)); 
	jtb.addSeparator();       
        jtb.add(bjb("Fine", fin));
        jtb.add(bjb("Medium", med));
        jtb.add(bjb("Heavy", hev));
	jtb.add(bjb("Fat", fat));
	jtb.addSeparator();
	jtb.add(bjb("black", blk));
	jtb.add(bjb("blue", blu));
	jtb.add(bjb("red", red));
	jtb.addSeparator();
        jtb.add(bjb("Default Highlighter", highdef));
        jtb.add(bjb("Yellow Highlighter", highyel));
        jtb.add(bjb("Magenta Highlighter", highmag));
	jtb.add(bjb("White Out", white));
	jtb.addSeparator();
	jtb.add(bjb("Razor", razor));
	jtb.add(bjb("Ruler", ruler));
	jtb.add(bjb("Select", select));
        jtb.add(bjb("Eraser", eraser));
	jtb.addSeparator();
	jtb.add(bjb("Stamp Date", clock));
	jtb.addSeparator();
	jtb.add(bjb("Text", text));
        container.add(jtb, BorderLayout.WEST);
        x.add(jtb, BorderLayout.SOUTH);

	jth.highlighter = true;
	jth.color = "yellow";
	jth.setWidth("Fat");
		
        jrnlPane = new JrnlPane();
	jrnlPane.setMeta();
        jrnlPane.setup();

	jrnlPane.dotC = toolkit.createCustomCursor(cursorD, new Point(1,1), "dot");
	jrnlPane.blankC = toolkit.createCustomCursor(cursorB, new Point(1,1), "blank");
	jrnlPane.boxC = toolkit.createCustomCursor(cursorX, new Point(8,8), "box");
	jrnlPane.whiteC = toolkit.createCustomCursor(cursorW, new Point(8,8), "white");
	jrnlPane.highC = toolkit.createCustomCursor(cursorH, new Point(8,8), "high");

	jrnlPane.open();
	jrnlPane.setCursor();
        JScrollPane sp = new JScrollPane(jrnlPane);
        JScrollBar sb = sp.getHorizontalScrollBar();
        JScrollBar sv = sp.getVerticalScrollBar();
        sv.setUnitIncrement(10);
        sb.setUnitIncrement(100);
        sp.setInputMap(javax.swing.JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, null);
        container.add(sp, BorderLayout.CENTER);
		
        statusBar = new JLabel("Edit");
        container.add(statusBar, BorderLayout.SOUTH);

        jrnlPane.addMouseListener(new JrnlMouseListener());
        jrnlPane.addMouseMotionListener(new JrnlMouseMotionListener());
        jrnlPane.addKeyListener(new Jarnalkey());
		
        return jrnlPane;
    }

    public void addBookmark(String bmark){
	if(!updateBookmarks) return;
	if(bookmarks.add(bmark) && saveBookmarks) dirty = true;
	bmk.removeAll();
	dbmk.removeAll();
	for (Iterator i = bookmarks.iterator(); i.hasNext(); ){
		String bname = (String) i.next();
		bmk.add(bmi("file:/" + bname));
		dbmk.add(bmi("delete:/" + bname));
	}
    }

    public void makeAllBookmarks(){
	allbmk.removeAll();
	for (Iterator i = allBookmarks.iterator(); i.hasNext(); ){
		String bname = (String) i.next();
		allbmk.add(bmi("file:/" + bname));
	}
    }

    public void addBookmarkAll(String bmark){
	allBookmarks.add(bmark);
	makeAllBookmarks();
	for (Iterator i = wins.iterator(); i.hasNext(); ){
		((Jarnal)i.next()).addBookmark(bmark);
	}
    }	

    String getBookmarks(){
	String s = "";
	for (Iterator i = bookmarks.iterator(); i.hasNext(); ){
		s = s + ((String)i.next()) + "\n";
	}
	return s;
    }

    void setBookmarks(String s){
	s = s + "\n";
	int n = s.indexOf("\n");
	s = s.substring(n + 1);
	n = s.indexOf("\n");
	while(n > 0){
		addBookmark(s.substring(0,n));
		allBookmarks.add(s.substring(0,n));
		s = s.substring(n + 1);
		n = s.indexOf("\n");
	}
	dirty = false;
	makeAllBookmarks();
    }
		

    private class JrnlClosing extends WindowAdapter {

	public void windowClosing(WindowEvent e){
		if(jrnlPane.winDone()) {
			Window win = e.getWindow();
			win.setVisible(false); 
			checkClose();
		}
	}
    }

    private class JrnlSizeListener implements ComponentListener{
	public void componentResized(ComponentEvent e){
		if(fitWidth) jrnlPane.resize();
		else jrnlPane.setup();
	}
	public void componentMoved(ComponentEvent e){
	}
	public void componentShown(ComponentEvent e){
	}
	public void componentHidden(ComponentEvent e){
	}
    }
		
    private class JrnlActionListener implements ActionListener {
        private String action;
        private JButton button;
        public JrnlActionListener(String action, JButton button){
            this.action = action;
            this.button = button;
        }
        
        public JrnlActionListener(String action){
            this.action = action;
            button = null;
        }
        
        public void actionPerformed(ActionEvent e){    
	    jrnlPane.doAction(action);
	}
    }

//mouse drawing operations

    int drawState = 0;
    int cnt = 0;
    Point2D.Double x[] = new Point2D.Double[10000];
    int xx[] = new int[100];
    int yy[] = new int[100];
    int xxx[] = new int[100];
    int yyy[] = new int[100];
    int xmax, ymax, xmin, ymin, rad;
    int cc;
    int maxcc = 4;
    boolean dragOpFinished = false;
	
    private class JrnlMouseListener extends MouseAdapter {
	
        public void mousePressed(MouseEvent e) {
            int X = e.getX();
	    int Y = e.getY();
	    Point2D.Double startL = new Point2D.Double((double) X, (double) Y);
	    jrnlPane.startStroke(startL);
	    cnt = 0;
	    rad = (int) Math.ceil(jrnlPane.getStroke()/2);
	    jrnlPane.initDraw(X, Y);
	    dragOpFinished = false;
	    if(dragOp > 0) {
		jrnlPane.startDragOp();
		if((dragOp == 1) || (dragOp == 4) || (dragOp == 5)) {
			drawState = 0;
			jrnlPane.repaint();
		}
	    }
	    if(textMode && (dragOp == 0)) jrnlPane.startText(startL);
        }

	public void mouseClicked(MouseEvent e){
	    if(dragOp == 100){
		dragOp = 0;
		drawState = 0;
		jrnlPane.pickpage(e.getX(), e.getY());
		jrnlPane.repaint();
		jrnlPane.requestFocus();
		return;
	    }
	    if((dragOp != 0) || (dragOpFinished)) {
		dragOpFinished = true;
		return;
	    }
	    if(textMode) return;
	    Point2D.Double startL = new Point2D.Double((double) e.getX(), (double) e.getY());
	    jrnlPane.click(startL);
	    drawState = 1; 
	    if(!jt.highlighter) {
		Rectangle r = jrnlPane.drawLast();
		jrnlPane.repaint(r);
		return;
	    }
	    if(jt.highlighter) drawState = 0;
            jrnlPane.repaint();
            jrnlPane.requestFocus();
	}

	public void mouseReleased(MouseEvent e){
		//draw or ruler
		if(dragOp <= 0){
			if(textMode) return;
			drawState = 1;
			for(int i = 0; i < cnt; i++) jrnlPane.stroke(x[i]);
			if(!jt.highlighter && cnt > 0) {
				cnt = 0;
				Rectangle r = jrnlPane.drawLast();
				jrnlPane.repaint(r);
				dragOpFinished = true;
				dragOp = 0;
				return;
			}
			if(!jt.highlighter && (cnt == 0) && (dragOp <= 0)) return;
			cnt = 0;
			if(dragOp == -1) drawState = 0;
			if(jt.highlighter) drawState = 0;
			jrnlPane.repaint();
			if(dragOp != 0) dragOpFinished = true;
			dragOp = 0;
			return;
		}
		//read only
		if(dragOp == 100) return;
		drawState = 0;
		jrnlPane.repaint();
		jrnlPane.setCursor();
		if(dragOp != 0) dragOpFinished = true;
		dragOp = 0;
		jrnlPane.endDragOp();
		cnt = 0;
	}
    }
	
    private class JrnlMouseMotionListener extends MouseMotionAdapter {

        public void mouseDragged(MouseEvent e) {
            int X = e.getX();
	    int Y = e.getY();
	    //ruler
	    if(dragOp == -1){
		cnt = 0;
		cc = 1;
	    }
	    x[cnt] = new Point2D.Double((double) X, (double) Y);
	    cnt++;
	    xx[cc] = X;
            yy[cc] = Y;
            cc++;
	    if(X < xmin) xmin = X;
	    if(X > xmax) xmax = X;
	    if(Y < ymin) ymin = Y;
	    if(Y > ymax) ymax = Y;
	    //next step should only be possible if dragOp == 0
	    if((cc == maxcc) && !textMode){
	        int z[] = xxx;
		xxx = xx;
		xx = z;
		z = yyy;
		yyy = yy;
		yy = z;
		int xxmin = xmin;
		int xxmax = xmax;
		int yymin = ymin;
		int yymax = ymax;
		jrnlPane.initDraw(X, Y);
		drawState = 2; 
		jrnlPane.repaint(1l, xxmin - rad, yymin - rad, xxmax - xxmin + (2*rad), yymax - yymin + (2*rad));	
	    }
	    else if(textMode && (dragOp == 0)){
		cnt = 0;
		if(cc == maxcc){
			jrnlPane.dragText(X, Y);
			cc = 1;
		}
	    }
	    if (dragOp == 0) return;
	    //ruler
	    if(dragOp == -1){
		drawState = -1; 
		jrnlPane.repaint(1l, xmin - rad, ymin - rad, xmax - xmin + (2*rad), ymax - ymin + (2*rad));	
	    } 
	    //read only 
	    if(dragOp == 100) {
		cc = 1;
		cnt = 0;
	    }
	    //razor or select
	    else if(dragOp > 0){
		drawState = 0;
		jrnlPane.repaint();
		cc = 1;
	    }
        }
    }

    int keyCode;
    boolean ctrl = false;
    boolean alt = false;
    boolean shift = false;

    private class Jarnalkey extends KeyAdapter{
        int keyChar;
        int SHIFT = 16;
        int CTRL = 17;
        int ALT = 18;
	public void keyPressed(KeyEvent e){
		if(dragOp == 100) return;
		keyCode = e.getKeyCode();
		if(keyCode == SHIFT) shift = true;
		if(keyCode == CTRL) ctrl = true;
		if(keyCode == ALT) alt = true;
		String op = "adv";
		if(ctrl) op = "extend";
            	if(keyCode == 39) {
                	jrnlPane.textOp(op, 1, null);
                	jrnlPane.textOp("show", 0, null);
            	}
            	else if(keyCode == 37) {
                	jrnlPane.textOp(op, -1, null);
                	jrnlPane.textOp("show", 0, null);
            }
	}
        public void keyTyped(KeyEvent e) {
		if(dragOp == 100) return;
		keyChar = e.getKeyChar();
            	if(keyCode == 8) {
                	jrnlPane.textOp("extendEmpty", -1, null);
                	jrnlPane.textOp("type", 0, "");
            	}
            	else if(keyCode == 127) {
                	jrnlPane.textOp("extendEmpty", 1, null);
                	jrnlPane.textOp("type", 0, "");
            	}
		else if(keyCode == 10) jrnlPane.textOp("type", 0, "\n");
	    	else if(ctrl & (keyChar == 26)) jrnlPane.doAction("Undo");
	    	else if(ctrl & (keyChar == 24)) jrnlPane.doAction("Cut Text");
	    	else if(ctrl & (keyChar == 3)) jrnlPane.doAction("Copy Text");
	    	else if(ctrl & (keyChar == 22)) jrnlPane.doAction("Paste Text");
		else if(ctrl & (keyCode == 66)) jrnlPane.textOp("style", 0, "Bold");
		else if(ctrl & (keyCode == 73)) jrnlPane.textOp("style", 0, "Italic");
		else jrnlPane.textOp("type", keyChar, null);
	}
        public void keyReleased(KeyEvent e){
		if(dragOp == 100) return;
		keyCode = e.getKeyCode();
		if(keyCode == SHIFT) shift = false;
		if(keyCode == CTRL) ctrl = false;
		if(keyCode == ALT) alt = false;
	}
    }

    class ffilter extends javax.swing.filechooser.FileFilter{
	public boolean accept(File f){
		if(!f.isFile()) return true;
		String fn = f.getName();
		if(fn.length() < 4) return false;
		String fnext = fn.substring(fn.length() - 4, fn.length());
		if(fnext.equals(ext)) return true;
		return false;
	}
	public String getDescription(){
		return "Jarnal Files";
	}
    }

    private class JrnlDialogButtonListener implements ActionListener {
	private JTextField server;
	private JTextArea options;
	private JDialog jw;
	private String action;

	public JrnlDialogButtonListener(String action, JTextField server, JTextArea options, JDialog jw){
		this.server = server;
		this.options = options;
		this.jw = jw;
		this.action = action;
	}
	public void actionPerformed(ActionEvent e){
		if(action.equals("cancel")) jw.setVisible(false);
		if(action.equals("ok")){
			netServer = server.getText();
			netOptions = options.getText();
			jw.setVisible(false);	
			dirty = true;
			jrnlPane.setStatus("");
		}
	}
    }
    
//Main window    
	
    class JrnlPane extends JPanel implements Printable {
    
	private Cursor standardC = new Cursor(Cursor.DEFAULT_CURSOR);
	public Cursor dotC = null; 
	public Cursor blankC = null;
	public Cursor boxC = null;
	public Cursor whiteC = null;
	public Cursor highC = null;

	public void JrnlPane() {}

	public Jpages jpages = new Jpages();
	private BufferedImage gg;
	private Graphics2D gg2;

	private Rectangle clipR = new Rectangle(0,0,1,1);

	public void standardCursor() {setCursor(standardC);}
	public void dotCursor() {setCursor(dotC);}
	public void blankCursor() {setCursor(blankC);}
	public void boxCursor(){setCursor(boxC);}
	public void whiteCursor(){setCursor(whiteC);}
	public void highCursor(){setCursor(highC);}
	public void textCursor(){setCursor(standardC);}

//API begins here

	public void textOp(String op, int data, String str){
		if(op.equals("type")){
			if(str == null){
				char y = (char) data;
				Character z = new Character(y);
				str = z.toString();
			}
			clipR = jpages.typeKey(str, jt);
			dirty = true;
			op = "show";
		}
		if(op.equals("style")){
			clipR = null;
			op = "show";
			dirty = true;
			if(str.equals("Bold")) clipR = jpages.setSelStyle(true, false, false, null, null, null);
			if(str.equals("Italic")) clipR = jpages.setSelStyle(false, true, false, null, null, null);
			if(str.equals("Underline")) clipR = jpages.setSelStyle(false, false, true, null, null, null);
			if(str.equals("Size")) clipR = jpages.setSelStyle(false, false, false, new Float(data), null, null);
			if(str.length() >= 5){
				if(str.substring(0,5).equals("Font ")){
					String font = str.substring(5);
					clipR = jpages.setSelStyle(false, false, false, null, font, null);
				}
			}
			if(str.length() >= 5){
				if(str.substring(0,5).equals("Color")){
					String color = str.substring(5);
					clipR = jpages.setSelStyle(false, false, false, null, null, color);
				}
			}
		}
		if(op.equals("extendEmpty")){
			clipR = jpages.adv(data, 2);
		}
		if(op.equals("extend")){
			clipR = jpages.adv(data, 1);
		}
		if(op.equals("adv")){
			clipR = jpages.adv(data, 0);
		}
		if(op.equals("show")){
			drawState = 7;
			if(clipR != null) jrnlPane.repaint(1l, (int) clipR.getX(), (int) clipR.getY(), clipR.width, clipR.height);
		}
		setStatus("");
			
	}

	public void stroke(Point2D.Double endL){
		jpages.stroke(endL);
		dirty = true;
	}

	public void startStroke(Point2D.Double endL){
		jpages.startStroke(endL, jt);
	}

	public void startText(Point2D.Double endL){
		clipR = jpages.startText(endL);
		setStatus("");
		if(clipR == null){
			drawState = 0;
			jrnlPane.repaint();
		}
		else{
			drawState = 7;
			jrnlPane.repaint(1l, (int) clipR.getX(), (int) clipR.getY(), clipR.width, clipR.height);
		}
	}

	public void dragText(int x, int y){
		clipR = jpages.dragText(x, y);
		drawState = 7;
		if(clipR != null) jrnlPane.repaint(1l, (int) clipR.getX(), (int) clipR.getY(), clipR.width, clipR.height);
	}

	public void startDragOp(){
		jpages.startDragOp(dragOp);
	}

	public void endDragOp(){
		jpages.endDragOp();
	}

	public void click(Point2D.Double endL){
		jpages.click(endL, jt);
		dirty = true;
	}

	public Rectangle drawLast(){
		return jpages.drawLast();
	}

//end of API

	private String fixDate(int i){
		String s = "" + i;
		if(s.length() == 1) s = "0" + s;
		return s;
	} 

	public void initDraw(int X, int Y){
		cc = 0;
	    	xx[cc] = X;
            	yy[cc] = Y;
		cc = 1;
		xmin = X;
		xmax = X;
		ymin = Y;
		ymax = Y;
	}

	public float getStroke(){
		float x = jt.getWidth();
		if((jt.type.equals("Fat")) && jt.highlighter) x = jt.getHeavy();
		return x * jpages.getScale();
	}

	private void netSaveDialog(Point p, Rectangle r){

	    JDialog jw = new JDialog(gJrnlFrame, "Network Save Options");
            jw.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
            GridLayout gl = new GridLayout(3,2);
            Container jwc = jw.getContentPane();
            jwc.setLayout(gl);
            jwc.add(new JLabel("Server"));
	    JTextField server = new JTextField(netServer);
            jwc.add(server);
            jwc.add(new JLabel("Variables"));
	    JTextArea options = new JTextArea(netOptions, 10, 30);
            jwc.add(options);
            JButton ok = new JButton("OK");
	    jwc.add(ok);
	    ok.addActionListener(new JrnlDialogButtonListener("ok", server, options, jw));
	    JButton cancel = new JButton("Cancel");
	    cancel.addActionListener(new JrnlDialogButtonListener("cancel", server, options, jw));
	    jwc.add(cancel);
            if(p != null){
                int h = r.height;
                int w = r.width;
                p.y += h;
                jw.setLocation(p);
            }
            jw.setSize(new Dimension(300, 200));
            jw.setVisible(true);
	}

	public void about(){
		InputStream in = Jarnal.class.getResourceAsStream("ver.txt");
		int nmax = 10000;
		byte b[] = new byte[nmax];
		String s = "";
		int nread = 0;
		try { nread = in.read(b); }
		catch (Exception e) {System.err.println(e);}
		s = new String(b,0,nread);
		JOptionPane.showConfirmDialog(gJrnlFrame, "Jarnal is a pen-centric journaling program. \nversion " + s.trim() + "\nWritten by David K. Levine, August 2003 and placed in the public domain. \nCode and documentation at http://www.dklevine.com/general/software/tc1000/jarnal.htm.",    "About Jarnal", JOptionPane.DEFAULT_OPTION);
	}

	private String getConf(){
		String s = "";
		s = s + "[Globals]\n";
		s = s + "pageNumber=" + jpages.getPage() + "\n";
		s = s + "scale=" + jpages.getScale() + "\n";
		s = s + "highlightLines=" + jpages.highlightLines + "\n";
		s = s + "fitWidth=" + fitWidth + "\n";
		s = s + jpages.getDefaultPaper();
		Dimension d = gJrnlFrame.getSize();
		s = s + "windowHeight=" + d.getHeight() + "\n";
		s = s + "windowWidth=" + d.getWidth() + "\n";
		s = s + "textMode=" + textMode + "\n";
		if(!netServer.equals(""))s = s + "netServer=" + netServer + "\n";
		s = s + "saveOnExit=" + saveOnExit + "\n";
		s = s + "saveBookmarks=" + saveBookmarks + "\n";
		s = s + "updateBookmarks=" + updateBookmarks + "\n";
		s = s + "saveBg=" + saveBg + "\n";
		s = s + "defaultText=" + jpages.getParms() + "\n";
		if((!bgfile.equals("")) && (!saveBg)) s = s + "backgroundFile=" + bgfile + "\n";
		s = s + "\n";
		s = s + "[Default Pen]\n" + jtd.getConf() + "\n";
		s = s + "[Default Highlighter]\n" + jth.getConf() + "\n";
		s = s + "[Current Tool]\n" + jt.getConf() + "\n";
		if(saveBookmarks){
			s = s + "[Bookmarks]\n" + getBookmarks() + "\n";
		}
		if(!netOptions.equals("")){
			s = s + "[Net Options]\n" + netOptions + "\n\n";
		}
		return s;
	}

	public void setDefaultConf(){
		setConf("[Globals]\npageNumber=1\nscale=0.97759104\nhighlightLines=false\nfitWidth=true\npaper=Lined\nlines=25\nheight=861\nwidth=714\nwindowHeight=992.0\nwindowWidth=738.0\ntextMode=false\nsaveOnExit=false\nsaveBookmarks=false\nupdateBookmarks=true\nsaveBg=false\ndefaultText=font-family=\"Vera\" font-size=\"20\" fill=\"black\"\n\n[Default Pen]\ntype=Medium\ncolor=black\nhighlighter=false\n\n[Default Highlighter]\ntype=Fat\ncolor=yellow\nhighlighter=true\n\n[Current Tool]\ntype=Medium\ncolor=black\nhighlighter=false\n\n");
		netServer="";
		netOptions="";
	}

	public void setConf(String s){
		String z;

		s = s + "\n";

		String y = Jtool.getEntry(s, "[Globals]");
		jpages.setDefaultPaper(y);
		z = Jtool.getLine(y, "pageNumber");
		if(z != null){
			int p = Integer.parseInt(z);
			if(p > 1) jpages.nextPage(p - 1);
		}
		z = Jtool.getLine(y, "saveBg");
		if(z != null) {
			if(z.equals("true")) saveBg = true;
			sbg.setState(saveBg);
			jpages.saveBg = saveBg;
		}
		z = Jtool.getLine(y, "backgroundFile");
		if(z != null) {
			bgfile = z;
			jpages.openBg(bgfile);
		}
		z = Jtool.getLine(y, "highlightLines");
		if(z != null){
			if(z.equals("true")) jpages.highlightLines = true;
			else jpages.highlightLines = false;
		}
		z = Jtool.getLine(y, "scale");
		if(z != null) jpages.setScale(Float.parseFloat(z));
		z = Jtool.getLine(y, "fitWidth");
		if(z != null){
			if(z.equals("true")) fitWidth = true;
			else fitWidth = false;
		}
		z = Jtool.getLine(y, "windowWidth");
		if(z != null){
			int w = (int) Float.parseFloat(z);
			z = Jtool.getLine(y, "windowHeight");
			if(z != null){
				int h = (int) Float.parseFloat(z);
				frameSize = new Dimension(w, h);
			}
		}
		z = Jtool.getLine(y, "netServer");
		if(z != null) {
			netServer = z;
		}
		z = Jtool.getLine(y, "saveOnExit");
		if(z != null) {
			if(z.equals("true")) saveOnExit = true;
			soe.setState(saveOnExit);
		}
		z = Jtool.getLine(y, "saveBookmarks");
		if(z != null) {
			if(z.equals("true")) saveBookmarks = true;
			sbmk.setState(saveBookmarks);
		}
		z = Jtool.getLine(y, "updateBookmarks");
		if(z != null) {
			if(z.equals("false")) updateBookmarks = false;
			abmk.setState(updateBookmarks);
		}
		z = Jtool.getLine(y, "textMode");
		if(z != null){
			if(z.equals("true")) textMode = true;
		}
		z = Jtool.getLine(y, "defaultText");
		if(z != null) jpages.setParms(z);

		y = Jtool.getEntry(s, "[Bookmarks]");
		if(y != null) setBookmarks(y);
		
		Jtool jtt = Jtool.getTool(Jtool.getEntry(s, "[Default Pen]"));
		if(jtt != null) jtd = jtt;
		jtt = Jtool.getTool(Jtool.getEntry(s, "[Default Highlighter]"));
		if(jtt != null) jth = jtt;
		jtt = Jtool.getTool(Jtool.getEntry(s, "[Current Tool]"));
		if(jtt != null) jt = jtt;

		z = Jtool.getEntry(s, "[Net Options]");
		if(z != null) {
			int pos = z.indexOf("\n");
			netOptions = z.substring(pos + 1);
		}
	}

	public void setMeta(){
		String z;
		String s = meta;
		s = s + "\n";
		String y = Jtool.getEntry(s, "[Globals]");
		z = Jtool.getLine(y, "backgroundFile");
		if(z != null) {
			openbgfile = z;
		}
		z = Jtool.getLine(y, "jarnalFile");
		if(z != null) {
			openfile = z;
		}
		z = Jtool.getLine(y, "templateFile");
		if(z != null) {
			template = true;
			openfile = z;
		}
		z = Jtool.getLine(y, "netServer");
		if(z != null) {
			netServer = z;
		}
		netOptions = null;
		netOptions = Jtool.getEntry(s, "[Net Options]");
		if(netOptions != null) {
			int pos = netOptions.indexOf("\n");
			netOptions = netOptions.substring(pos + 1);
		}
		else netOptions = "";
		pipe();
	}

	public void notImplemented(){
		JOptionPane.showConfirmDialog(gJrnlFrame, "Option not implemented",    "Fix me", JOptionPane.DEFAULT_OPTION);
	}

	public boolean winDone(){
		if(saveOnExit && dirty && (fname != "")){
			jrnlPane.doAction("Save");
			return true;
		}
		int n = 0;
		if(dirty) n = JOptionPane.showConfirmDialog(gJrnlFrame, "All unsaved data will be lost. OK to exit?",    "Confirm Exit", JOptionPane.YES_NO_OPTION);
		if(n == 0) return true;
		return false;
	}	

	private String suggestName(){
		GregorianCalendar cal = new GregorianCalendar();
		String sug = "" + cal.get(Calendar.YEAR) + "_" + fixDate(cal.get(Calendar.MONTH) - Calendar.JANUARY + 1) + "_" + fixDate(cal.get(Calendar.DATE)) + "_" + fixDate(cal.get(Calendar.HOUR_OF_DAY)) + "_" + fixDate(cal.get(Calendar.MINUTE)) + "_" + fixDate(cal.get(Calendar.SECOND));
		return sug;
	}	

	private String getFile(String type, boolean setFilter){
		JFileChooser fd = new JFileChooser(cwd);
		if(setFilter) fd.setFileFilter(new ffilter());
		if(type.substring(0,4).equals("Open")) fd.showOpenDialog(gJrnlFrame);
		else {
			String sug = suggestName();
			String zext = ext;
			if(type.equals("Save Snapshot")) zext = ".jpg";
			fd.setSelectedFile(new File(sug + zext));
			int test = fd.showSaveDialog(gJrnlFrame);
			if(test == JFileChooser.CANCEL_OPTION) return null;
		}
		String temp = fd.getName(fd.getSelectedFile());
		if (temp == null) return null;
		File tdir = fd.getCurrentDirectory();
		cwd = tdir.getPath();			
		return temp;
	}

	public String getDate(){
		//java.text.DateFormat df = java.text.DateFormat.getDateTimeInstance(java.text.DateFormat.DEFAULT, java.text.DateFormat.DEFAULT);
		java.text.SimpleDateFormat df = new java.text.SimpleDateFormat("EEE MMM d, yyyy h:mm a");
		Date now = new Date();
		return df.format(now);
	}

	public void open(){
		String obgfile = bgfile;
		boolean setSizeToBg = false;
		if(!openfile.equals("")) {
			if(!template){
				File temp = new File(openfile);
				fname = temp.getName();
				cwd = temp.getParent();
			}
			setConf(jpages.open(openfile));
			addBookmarkAll(openfile);
		}
		else setSizeToBg = true;
		if(template && (jpages.getPages() == 1)) setSizeToBg = true;
		openfile = "";
		if(!obgfile.equals("")) bgfile = obgfile;
		if(!bgfile.equals("")) {
			jpages.openBg(bgfile);
			if(setSizeToBg) jpages.setSizeToBg();
		}
		template = false;
	}

	public void load(){
		setConf(jpages.open(cwd + File.separator + fname));
		addBookmarkAll(cwd + File.separator + fname);
            	jrnlPane.repaint();
            	jrnlPane.requestFocus();
	}

	public void openName(String cwdt, String temp){
		if(temp != null) {
			if(fname != ""){
				Jarnal newJ = Jarnal.newJarnal("Jarnal - " + temp);
				newJ.setDirs(cwdt, temp);
			}
			else{
				fname = temp;
				cwd = cwdt;
				gJrnlFrame.setTitle("Jarnal - " + temp);
				jpages = new Jpages();
				drawState = 0;
				load();
				return;
			}
		}
	}

	public void setWidth(String width){
		jt.setWidth(width);
		setStatus("");
		if(!jt.highlighter) old_color = jt.color;
	}

	public void doAction(String action){

	    jrnlPane.requestFocus();

	    if(dragOp != 100) {
		dragOp = 0;
		setCursor();
	    }
	    jrnlPane.setStatus("");
	    drawState = 0;

	    if(action.equals("Thumbs")){
		if(dragOp == 100) {
			dragOp = 0;
			drawState = 0;
			setCursor();
		}
		else {
			dragOp = 100;
			standardCursor();
		}
	    }

	    if(action.equals("About")) about();

	    if(action.equals("Save On Exit")){
		saveOnExit = !saveOnExit;
		soe.setState(saveOnExit);
		dirty = true;
		setStatus("");
		return;
	    }

	    if(action.equals("Network Save Options")){
		netSaveDialog(null, null);
		return;
	    }

	    if(action.equals("Save Bookmarks")){
		saveBookmarks = !saveBookmarks;
		sbmk.setState(saveBookmarks);
		dirty = true;
		setStatus("");
		return;
	    }

	    if(action.equals("Save Background With File")){
		saveBg = !saveBg;
		sbg.setState(saveBg);
		jpages.saveBg = saveBg;
		dirty=true;
		setStatus("");
	    }

	    if(action.equals("Autoupdate Bookmarks")){
		updateBookmarks = !updateBookmarks;
		abmk.setState(updateBookmarks);
		dirty = true;
		setStatus("");
		return;
	    }

	    if(action.equals("Text")){
		textMode = !textMode;
		setCursor();
		dirty = true;
		setStatus("");
		return;
	    }

	    if(action.equals("Print")){
		PrinterJob pj = PrinterJob.getPrinterJob();
		if(pj.printDialog()){
			pj.setPrintable(jrnlPane);
			try {
				pj.print();
			}
			catch(PrinterException pe){
				System.out.println(pe.toString());
			}
		}
	    	return;
	    }

	    if(action.equals("Restore Default Configuration")){
		setDefaultConf();
		dirty = true;
		setCursor();
		setStatus("");
	    }

	    int pageChange = 0;

	    if(action.equals("Previous Page")) pageChange = -1;
	    if(action.equals("Next Page")) pageChange = 1;
	    if(action.equals("First Page")) pageChange = -1000;
	    if(action.equals("Last Page")) pageChange = 1000;
	    if(pageChange != 0){
		if(jpages.nextPage(pageChange) && action.equals("Next Page")) action = "New Page";
		if (fitWidth) resize();
		else setup();
	    }


	    if(action.equals("New")) {
		Jarnal jrnl = Jarnal.newJarnal("Jarnal");
		jrnl.jrnlPane.setConf(getConf());
		jrnl.saveBookmarks = false;
		jrnl.jrnlPane.setCursor();
		return;
	    }

	    if(action.equals("Network Save")){
		Hashtable ht = new Hashtable();
		String tfname = fname;
		if(tfname.equals("")) tfname="unsaved.jaj";
		ht.put("$f", tfname);
		ht.put("$p", cwd + File.separator + tfname);
		ht.put("$n", "" + jpages.getPages());
		if(uniqueID == null) uniqueID = suggestName() + Long.toString((new Random()).nextLong(), 36);
		ht.put("$u", uniqueID);
		HtmlPost hp = new HtmlPost(netServer, netOptions, jpages, ht, getConf());
		hp.post();
		if(isApplet){
			dirty=false;
			setStatus("");
		}
		return;
	    }
            
	    if(action.equals("Save")){
		if(fname.equals("")){
			String temp = getFile("Save", true);
			if(temp == null) return;
			fname = temp;
			addBookmarkAll(cwd + File.separator + fname);
		}
		jpages.save(cwd + File.separator + fname, getConf());
		gJrnlFrame.setTitle("Jarnal - " + fname); 
		dirty = false;
		setStatus(""); 
		return;
	    }

            if(action.equals("Save As")){
		String temp = getFile("Save As", true);
		if(temp!=null){
			uniqueID = suggestName() + Long.toString((new Random()).nextLong(), 36);
			fname = temp;
			addBookmarkAll(cwd + File.separator + fname);
			jpages.save(cwd + File.separator + fname, getConf()); 
			gJrnlFrame.setTitle("Jarnal - " + fname); 
			dirty = false; 
			setStatus("");
		}
		return;
	    }

	    if(action.equals("Snapshot")){
		String oldcwd = cwd;
		String temp = getFile("Save Snapshot", false);
		if(temp!=null){
			writeGraphicFile(new File(cwd + File.separator + temp), "jpg");	
		}
		cwd = oldcwd;
	    }

	    if(action.equals("Open")){
		String oldcwd = cwd;
		String temp = getFile("Open", true);
		String newcwd = cwd;
		cwd = oldcwd;
		openName(newcwd, temp);
	    }

	   if(action.equals("Open Background")){
		String oldcwd = cwd;
		String temp = getFile("Open Background", false);
		String newcwd = cwd;
		cwd = oldcwd;
		bgfile = newcwd + File.separator + temp;
		jpages.openBg(bgfile);
		jpages.setScale(jpages.getScale());
		jpages.setSizeToBg();
		resize();
		dirty = true;
		setup();
	    }

	    if(action.equals("Remove Background")){
		bgfile = "";
		jpages.removeBg();
		dirty = true;
		setup();
	    }

	    if(action.equals("Exit")){
		if(winDone()){
			gJrnlFrame.setVisible(false);
			checkClose();
		}
		return;
	    }

	    if(action.equals("Zoom In")){
		fitWidth = false;
		jpages.upScale(1);
		setup();
	    }
            if(action.equals("Zoom Out")){
		fitWidth = false;
		jpages.upScale(-1);
		setup();
	    }
	    if(action.equals("Fit Width")){
		fitWidth = true;
		resize();
	    }

	    if(dragOp == 100){
	        jrnlPane.repaint();
            	jrnlPane.requestFocus();
	    	setStatus("");
		return;
	    }

	    if(action.equals("Black Text")) {textOp("style", 0, "Colorblack");}
	    if(action.equals("Blue Text")) {textOp("style", 0, "Colorblue");}
	    if(action.equals("Gray Text")) {textOp("style", 0, "Colordark gray");}
	    if(action.equals("Green Text")) {textOp("style", 0, "Colorgreen");}
	    if(action.equals("Magenta Text")) {textOp("style", 0, "Colormagenta");}
	    if(action.equals("Orange Text")) {textOp("style", 0, "Colororange");}
	    if(action.equals("Pink Text")) {textOp("style", 0, "Colorpink");}
	    if(action.equals("Red Text")) {textOp("style", 0, "Colorred");}
	    if(action.equals("White Text")) {textOp("style", 0, "Colorwhite");}
	    if(action.equals("Yellow Text")) {textOp("style", 0, "Coloryellow");}

	    if(action.equals("Bold Text")) textOp("style", 0, "Bold");
	    if(action.equals("Italic Text")) textOp("style", 0, "Italic");
	    if(action.equals("Underline Text")) textOp("style", 0, "Underline");

	    if(action.equals("Set Text Default")) jpages.setDefaultParms();

	    if(action.length() >= 7){
		if(action.substring(0,6).equals("file:/")){
			String temps = action.substring(6);
			File temp = new File(temps);
			openName(temp.getParent(), temp.getName());
			return;
		}
	    }


	    if(action.length() >= 9){
		if(action.substring(0,8).equals("delete:/")){
			String temps = action.substring(8);
			bookmarks.remove(temps);
			setBookmarks(getBookmarks());
			dirty = true;
			setStatus("");
			return;
		}
	    }

	    if(action.length() == 4){
		if(action.substring(2,4).equals("pt")){
			textOp("style", Integer.parseInt(action.substring(0,2).trim()), "Size");
		}
	    }

	    if(action.length() >= 5){
		if(action.substring(0,5).equals("Font ")){
			textOp("style", 0, action);
		}
	    }

	    if(action.equals("Stamp Date")) textOp("type", 0, getDate());
		
	    if(action.equals("Lined")) jpages.setPaper("Lined");
	    if(action.equals("Plain")) jpages.setPaper("Plain");
	    if(action.equals("Graph")) jpages.setPaper("Graph");
	    if(action.equals("Thick Lines")) jpages.setLines(15);
	    if(action.equals("Medium Lines")) jpages.setLines(25);
	    if(action.equals("Thin Lines")) jpages.setLines(35);

	    boolean resize = false;

	    if(action.equals("Toggle Landscape")) {jpages.toggleLandscape(); resize = true;}
	    if(action.equals("Toggle Background")) {jpages.toggleBackground(); resize = true;}
	    if(action.equals("translucent")){jpages.setTransparency(80); resize = true;}
	    if(action.equals("transparent")){jpages.setTransparency(40); resize = true;}
	    if(action.equals("opaque")){jpages.setTransparency(255); resize = true;}
	    if(action.equals("Index Card")) {
		jpages.setHeight(3.0f);
		jpages.setWidth(5.0f);
		jpages.setLines(35);
		resize = true;
	    }
	    if(action.equals("Normal Size")) {
		jpages.setHeight(10.25f);
		jpages.setWidth(8.5f);
		jpages.setLines(25);
		resize = true;
	    }
	    if(action.equals("Fit to Background")){
		jpages.setSizeToBg();
		resize = true;
	    }
	    if(resize){
		if (fitWidth) resize();
		else setup();
	    }

	    if(action.equals("Razor")) {dragOp = 1; dirty = true; standardCursor();}
	    if(action.equals("Select")) {dragOp = 2; dirty = true; standardCursor();}
	    if(action.equals("Eraser")) {dragOp = 3; dirty = true; boxCursor();}
	    if(action.equals("Ruler")) {dragOp = -1; dirty = true;}
	    if(action.equals("Top Eraser")) {dragOp = 4; dirty = true;}
	    if(action.equals("Bottom Eraser")) {dragOp = 5; dirty = true;}
	    if((dragOp != 0 && dragOp != 100)) {
		jrnlPane.setStatus(action);
		return;
	    }

	    boolean penChanged = false;

	    if(action.equals("Default Pen")) {
		jt.fullCopy(jtd);
		penChanged = true;
	    }
	    if(action.equals("Default Highlighter")) {
		if(! ((jt.color.equals("white")) && (jt.type.equals("Fat")))) old_color = jt.color;
		jt.fullCopy(jth);
		penChanged = true;
	    }
	    if(action.equals("Set Default")) {
		if(jt.highlighter) jth.fullCopy(jt);
		else jtd.fullCopy(jt);
		penChanged = true;
	    }
	    if(action.equals("Set Fine")) {setWidth("Fine"); penChanged = true;}
	    if(action.equals("Set Medium")) {setWidth("Medium"); penChanged = true;}
	    if(action.equals("Set Heavy")) {setWidth("Heavy"); penChanged = true;}
	    if(action.equals("Set Fat")) {setWidth("Fat"); penChanged = true;}
	    if(action.equals("Highlighter")){
		if(! ((jt.color.equals("white")) && (jt.type.equals("Fat")))) old_color = jt.color;
		jt.highlighter = true;
		penChanged = true;
	    }
	    if(action.equals("Pen")){
		jt.highlighter = false;
		penChanged = true;
	    }
	    if(action.equals("Fine")){
		jt.highlighter = false;
		jt.color = old_color;
		setWidth("Fine");
		penChanged = true;
	    }
	    if(action.equals("Medium")){
		jt.highlighter = false;
		jt.color = old_color;
		setWidth("Medium");
		penChanged = true;
	    }
	    if(action.equals("Heavy")){
		jt.highlighter = false;
		jt.color = old_color;
		setWidth("Heavy");
		return;
	    }
	    if(action.equals("Fat")){
		jt.highlighter = false;
		jt.color = old_color;
		setWidth("Fat");
		penChanged = true;
	    }
	    if(action.equals("Yellow Highlighter")){
		if(! ((jt.color.equals("white")) && (jt.type.equals("Fat")))) old_color = jt.color;
		jt.highlighter = true;
		jt.color = "yellow";
		setWidth("Fat");
		penChanged = true;
	    }
	    if(action.equals("Magenta Highlighter")){
		if(! ((jt.color.equals("white")) && (jt.type.equals("Fat")))) old_color = jt.color;
		jt.highlighter = true;
		jt.color = "magenta";
		setWidth("Fat");
		penChanged = true;
	    }
	    if(action.equals("White Out")){
		if(!jt.highlighter) old_color = jt.color;
		jt.highlighter = false;
		jt.color = "white";
		setWidth("Fat");
		penChanged = true;
	    }
	    if(action.equals("black")) {jt.color = action; penChanged = true;}
	    if(action.equals("blue")) {jt.color = action; penChanged = true;}
	    if(action.equals("gray")) {jt.color = "dark gray"; penChanged = true;}
	    if(action.equals("green")) {jt.color = action; penChanged = true;}
	    if(action.equals("magenta")) {jt.color = action; penChanged = true;}
	    if(action.equals("orange")) {jt.color = action; penChanged = true;}
	    if(action.equals("pink")) {jt.color = action; penChanged = true;}
	    if(action.equals("red")) {jt.color = action; penChanged = true;}
	    if(action.equals("white")) {jt.color = action; penChanged = true;}
	    if(action.equals("yellow")) {jt.color = action; penChanged = true;}
	    if(!jt.highlighter && !(jt.color.equals("white") && jt.type.equals("Fat"))) old_color = jt.color;
	    if(penChanged){
		setStatus("");
		setCursor();
		return;
	    }

	    if(action.equals("Highlight Lines")) jpages.highlightLines = !jpages.highlightLines;

            if(action.equals("Undo")) {
		if(jpages.undo()) if (fitWidth) resize();
		dirty = true;
	    }
            if(action.equals("Redo")) {
		if(jpages.redo()) if (fitWidth) resize();
		dirty = true;
	    }

	    if(action.equals("Clear Page")){
		jpages.clearPage();
		if (fitWidth) resize();
		dirty = true;
	    }
	
	    if(action.equals("Duplicate Page")){
		jpages.pageDup();
		dirty = true;
	    }

	    if(action.equals("Insert Page After")){
		jpages.pageAfter("");
		jpages.setSizeToBg();
		if (fitWidth) resize();
		dirty = true;
	    }

	    if(action.equals("Insert Page Before")){
		jpages.pageBefore("");
		jpages.setSizeToBg();
		if (fitWidth) resize();
		dirty = true;
		jrnlPane.requestFocus();	    }

	    if(action.equals("New Page")){
		jpages.pageAfter("");
		jpages.newBg();
		jpages.setSizeToBg();
		if (fitWidth) resize();
		dirty = true;
	    }

	    if(action.equals("Delete Page")){
		jpages.pageDelete();
		if (fitWidth) resize();
		dirty = true;
	    }


	    if(action.equals("Replace Page") || action.equals("Paste Page After") || action.equals("Paste Page Before") || action.equals("Paste Text")){
		Clipboard clip = toolkit.getSystemClipboard();
		Transferable contents=clip.getContents(gJrnlFrame);
		if(contents==null) System.out.println("empty");
		else{
			try{
				int dtype = 0;
				if(contents.isDataFlavorSupported(DataFlavor.stringFlavor))dtype = 2;
				if(contents.isDataFlavorSupported(new DataFlavor("text/svg", "SVG Text Data")))dtype = 1;
				if(dtype > 0) {
					String data = null;
					if(dtype == 2) data = (String) contents.getTransferData(DataFlavor.stringFlavor);
					if(dtype == 1) data = (String) contents.getTransferData(new DataFlavor("text/svg", "SVG Text Data"));
     					if(data==null) System.out.println("no text");
     					else{
						if(action.equals("Paste Page After")) jpages.pageAfter(data);
						if(action.equals("Paste Page Before")) jpages.pageBefore(data);
						if(action.equals("Replace Page")) jpages.replacePage(data);
						if(action.equals("Paste Text")) textOp("type", 0, data);
						dirty = true;
					}
    				} 
				else System.out.println("Wrong flavor.");

			}
			catch(IOException ex){ System.out.println("IOException");} 
			catch(UnsupportedFlavorException ex){ System.out.println("UnsupportedFlavorException"); }
		}
		if (fitWidth) resize();
		setup();
	    }

	    if(action.equals("Copy Page") || action.equals("Cut Page")){
		Clipboard clip = toolkit.getSystemClipboard();
		JarnalSelection sel = jpages.copyPage();
		//StringSelection sel = new StringSelection(copy);
		clip.setContents(sel, sel);
		if(action.equals("Cut Page")){
			jpages.pageDelete();
			dirty = true;
		}
	    }

	    if(action.equals("Copy Text") || action.equals("Cut Text")){
		jpages.clipText(toolkit);
		if(action.equals("Cut Text")) textOp("type", 0, "");
	    }

            jrnlPane.repaint();
            jrnlPane.requestFocus();
	    setStatus("");
	}

	public void pickpage(int x, int y){
		int delta = 0;
		if(x > jpages.getWidth()/2) delta++;
		if(y > jpages.getHeight()/2) delta = delta + 1;
		jpages.nextPage(delta);	
		setCursor();
	}

	public void setStatus(String stat){
	    String dstring = "";
	    String fstring = "";
	    //if(dirty) dstring = " [Changed] ";
	    if(dirty || fname.equals("")) saveButton.setEnabled(true);
	    else saveButton.setEnabled(false);
	    if(textMode) fstring = " [Text]";
	    String tstring = jpages.getDesc();
            statusBar.setText("Page " + jpages.getPage() + " of " + jpages.getPages() + " " + dstring + fstring + " " + tstring + "  " + jt.desc() + " "  + stat + "  " + jpages.getPaperDesc());
	}

	public void setCursor(){
		if(jt.highlighter) highCursor();
		else if(jt.color.equals("white") && jt.type.equals("Fat")) whiteCursor();
		else dotCursor();
		if(textMode)textCursor();
	}

	public void resize () {
		Dimension d = gJrnlFrame.getSize();
		float dw = (float)(d.getWidth() - (2 * sbarSize));
		float scale = (float)(dw/jpages.getBaseWidth());
		jpages.setScale(scale);
		setup();
	}

        public void setup() {
		drawState = 0;
		Dimension canvasSize = new Dimension(jpages.getWidth(), jpages.getHeight());
		setSize(canvasSize);
		setPreferredSize(canvasSize);
        }

	boolean jpsetup = false;

    	public void paintComponent(Graphics g){
	    if(g == null) return;
	    setBackground(Color.white);
	    super.paintComponent(g);		

            Graphics2D g2 = (Graphics2D) g;
	    if(dragOp > 0) drawState = 0;
	    if(drawState == 2){
		if(gg2 == null) return;
		gg2.setPaint(jt.getColor());
		BasicStroke bs = new BasicStroke(getStroke(), BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND);
		gg2.setStroke(bs);
		gg2.drawPolyline(xxx, yyy, maxcc);
		g2.drawImage(gg, 0, 0, this);
		drawState = 0;
		return;
	    }
	    if(drawState == 7){
		if((gg2 == null) || (clipR == null)) return;
		gg2.setClip((int) clipR.getX(), (int) clipR.getY(), clipR.width, clipR.height);
		gg2.setBackground(Color.white);
		gg2.clearRect((int) clipR.getX(), (int) clipR.getY(), clipR.width, clipR.height);
		jpages.draw(gg2, (int) clipR.getX(), (int) clipR.getY(), clipR.width, clipR.height);
		g2.drawImage(gg, 0, 0, this);
		gg2.setClip(null);
		drawState = 0;
		return;
	    }
	    if(drawState == -1){
		if(gg == null) return;
		//super.paintComponent(g);
	    	int w = jpages.getWidth();
            	int h = jpages.getHeight(); 
		BufferedImage ggg = (BufferedImage)createImage(w, h);
		Graphics2D ggg2 = ggg.createGraphics();
		ggg2.drawImage(gg, 0, 0, this);
		ggg2.setPaint(jt.getColor());
		BasicStroke bs = new BasicStroke(getStroke(), BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND);
		ggg2.setStroke(bs);
		ggg2.drawPolyline(xx, yy, 2);
		g2.drawImage(ggg, 0, 0, this);
		drawState = 0;
		return;
	    }
	    if((dragOp == 100) && (drawState == 0)) drawState = 100;
            if((drawState == 100) || (drawState == 0)){
		if(dragOp == 0) for(int i = 0; i < cnt; i++) jrnlPane.stroke(x[i]);
		if((dragOp == -1) && (cnt > 0)) jrnlPane.stroke(x[cnt - 1]);
		else if((dragOp != 0) && (cnt > 0)) jpages.dragOp(x[cnt - 1]);
		cnt = 0;	
	    	int w = jpages.getWidth();
            	int h = jpages.getHeight();
		if(drawState == 0){ 
			gg = (BufferedImage)createImage(w, h);
			gg2 = gg.createGraphics();
			if(!jpsetup) Jpar.setGraphics(gg2);
		}
		else{
			gg = (BufferedImage)createImage(w/2, h/2);
			gg2 = gg.createGraphics();
		}
            	gg2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
            	gg2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
            	gg2.setRenderingHint(RenderingHints.KEY_FRACTIONALMETRICS, RenderingHints.VALUE_FRACTIONALMETRICS_ON);	
            	gg2.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
		if(drawState == 100){
			int ww = w/2;
			int hh = h/2;
			float scale = jpages.getScale();
			int firstPage = jpages.getPage() - 1;
			jpages.setScale(scale/2);
			for(int i = 0; i < 2; i++){
				for (int j = 0; j < 2; j++){
					if(firstPage + j + 2*i < jpages.getPages()) {
						gg2.setBackground(Color.white);
						gg2.clearRect(0, 0, ww, hh);
						jpages.draw(gg2);
						g2.drawImage(gg, ww*j, hh*i, this);
						jpages.nextPage(1);
					}	
				}			
			}
			jpages.setScale(scale);
			jpages.nextPage(firstPage - jpages.getPage() + 1);
			setStatus("");
			drawState = 0;
			return;
		}
		gg2.setBackground(Color.white);
		gg2.clearRect(0, 0, w, h);
		jpages.draw(gg2);
		this.requestFocus();
	    }
	    setStatus("");
	    if(gg != null) g2.drawImage(gg, 0, 0, this);
	    drawState = 1;
        }
    	public int print(Graphics g, PageFormat pf, int pi) throws PrinterException {
            	Graphics2D g2 = (Graphics2D) g;
		float scale = 1.0f;
		//AffineTransform at = new AffineTransform(0.64, 0.0, 0.0, 0.64, 72.0, 104.0);
		AffineTransform at = new AffineTransform(0.64, 0.0, 0.0, 0.64, 78.0, 104.0);
		g2.transform(at);
		if(jpages.print(g2, pi, scale)) {
			String pn = "" + (pi + 1);
			g2.setPaint(Color.darkGray);
			g2.drawString(pn, 20, 30);
			return Printable.PAGE_EXISTS;
		}
		else return Printable.NO_SUCH_PAGE;
	}
	public void writeGraphicFile(File f, String type){
	    jpages.writeGraphicFile(f, null, type);
	} 
    }
}

